#include <math.h>
#include <memory.h>
#include "matrix.h"
#include "geometry.h"

void SetRotationMatrix(double alpha, Matrix &matrix)
{
	matrix[0] = cos(alpha);
	matrix[1] = -sin(alpha);
	matrix[2] = sin(alpha);
	matrix[3] = cos(alpha);
}

void MultiplyMatrices(Matrix &dest, Matrix &left, Matrix &right)
{
	double ldet = left[0] * left[3] - left[1] * left[2];
	double rdet = right[0] * right[3] - right[1] * right[2];
	Matrix _dest;
	_dest[0] = left[0] * right[0] + left[1] * right[2];
	_dest[1] = left[0] * right[1] + left[1] * right[3];
	_dest[2] = left[2] * right[0] + left[3] * right[2];
	_dest[3] = left[2] * right[1] + left[3] * right[3];
	memcpy(dest, _dest, sizeof(Matrix));
}

void ApplyMatrixtoPoint(Matrix rot, _Point &point)
{
	double _x, _y;
	_x = point.x;
	_y = point.y;
	point.x = _x * rot[0] + _y * rot[1];
	point.y = _x * rot[2] + _y * rot[3];
}

